Bug 108684 - Installer should be able to upgrade NetBeans to a new version
Installer should be able to upgrade NetBeans to a new version
Status: NEW
Product: installer
Classification: Unclassified
Component: Code
8.2
All All
: P1 with 52 votes (vote)
: TBD
Assigned To: Libor Fischmeistr
issues@installer
:
: 134314 158674 178871 182444 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-07-02 19:03 UTC by _ tboudreau
Modified: 2017-05-21 05:10 UTC (History)
13 users (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments
Screen shot (75.34 KB, image/tiff)
2007-07-02 19:04 UTC, _ tboudreau
Details
Not funny anymore (if ever was) (26.21 KB, image/png)
2010-08-24 01:05 UTC, caesar2k
Details

Note You need to log in before you can comment on or make changes to this bug.
Description _ tboudreau 2007-07-02 19:03:32 UTC
See attached screen shot.  I am installing the July 7 build.  I have an install elsewhere of the June 14 build.  The installer is ominously complaining that it 
was deleted.

But what is this last line of text "Note that products that depend on the Base IDE will also be disabled:  Java IDE"

Hmm, what will it install?  There seems to be no choice but to say yes (it says if I say no to having Java IDE disabled, the installer will exist).  It suggests I 
will end up with only the bare platform.  The UI needs to differentiate between updating an existing copy and installing another copy somewhere else (in 
which case the old install doesn't matter).

Thankfully what really happens is it installs a functioning copy of NetBeans in a different directory.

Anyway, if an existing install is detected, somewhere early in the install cycle there needs to be something like:
Existing NetBeans install detected.  I want to:
  [x] Upgrade or change my existing NetBeans install
  [ ] Ignore it and install a copy of NetBeans somewhere else

or something like that.  If the user chooses to ignore it, they should never see the attached dialog.
Comment 1 _ tboudreau 2007-07-02 19:04:08 UTC
Created attachment 44637 [details]
Screen shot
Comment 2 Kirill Sorokin 2007-07-09 12:27:41 UTC
The problem here lies in the fact that both build of July 7 and the previous one (June 14) have components with
identical display names (Java IDE, UML, etc.). One set of them contains those built @ Jube 14th, the other (seemingly
identical) -- from July 7th. Currently there is no way for the user to differentiate between these.
Comment 3 dlipin 2008-03-27 14:18:17 UTC
We`ve just fixed Issue 115475 that is the first part of Tim`s issue.

So I leave this issue with the following brief description. Given such this issue becomes a big enhancement since 
multiple installation are not yet supported (see also Issue 88051, I leave both open for now).

The UI needs to differentiate between updating an existing copy and installing another copy somewhere else (in 
which case the old install doesn't matter).
Thankfully what really happens is it installs a functioning copy of NetBeans in a different directory.

Anyway, if an existing install is detected, somewhere early in the install cycle there needs to be something like:
Existing NetBeans install detected.  I want to:
  [x] Upgrade or change my existing NetBeans install
  [ ] Ignore it and install a copy of NetBeans somewhere else

or something like that.  If the user chooses to ignore it, they should never see the attached dialog.
Comment 4 dlipin 2008-05-01 20:51:40 UTC
*** Issue 134314 has been marked as a duplicate of this issue. ***
Comment 5 ejvyas 2008-05-02 00:36:53 UTC
Please raise the priority of this issue. I have 10 installations of Netbeans. If you do not want to lose testers and
interested community - I believe we should solve this ASAP
Comment 6 dlipin 2008-05-02 09:42:13 UTC
ejvyas, you can do it yourself with proper justification.

anyway, we have almost neither duplicates nor votes for this issue. Actually QA (at least, internal) is not interested 
in it all - I have never heard from them that they really miss this functionality. 
My personal tracking of NetBeans mailing lists haven`t resulted in understanding of high priority of this issue as well.
I am not saying that none requested the possibility of NetBeans upgrade but the number of requests is really low in 
comparison with overall traffic.

Could you please explain why is it important? Is it really a feature that much users really miss?
I realize that our internal vision (both development and QA) can be significantly different from the community`s one 
that is why I am asking.

Actually upgrade can be easily done in two steps - uninstall previous version and install the new one.
You can easily and fast, especially uninstallation, just run it silently (uninstall.exe --silent).
Comment 7 ejvyas 2008-05-02 13:43:07 UTC
I have voted for the issue. Please do not neglect it. I will not speak for others but I feel it is important to escalate
this issue. It is like having 10 versions of OS on the same machine which is absurd. I miss the feature and as a
netbeans user I want to have this escalated.
Comment 8 dlipin 2008-06-06 16:25:59 UTC
*** Issue 136669 has been marked as a duplicate of this issue. ***
Comment 9 tomzi 2008-08-20 10:28:31 UTC
I also would like this feature addressed. This is especially true, since updates and new version of nb are coming out
more frequently.

Nowadays it's quite normal to being notified if a new version of the current software is available and that you can
upgrade the current version. 

I think the even bigger issue is not 'just' the upgrade to the new netbeans version, but that all the current settings
and plugins are there as well. Until now, it was quite tedious to import all the new updatecenters, and external plugins
'again' and apply the settins for the plugins also (checkstyle, pmd, maven...).

See for example in Firefox. When you upgrade, the currently installed plugins and settings keep the same, just the
application is upgraded. Of course the plugins have to be checked if the new software is supported. However, Firefox
only disables not supported dependencies, but keeps checking for updates.

It would be also great to be notified, aka. being able to upgrade to current beta versions or even latest development
versions.
Comment 10 ejvyas 2008-08-20 13:11:55 UTC
I agree with tomzi. Many people have raised this issue
Comment 11 dlipin 2009-03-21 11:38:53 UTC
*** Issue 158674 has been marked as a duplicate of this issue. ***
Comment 12 dlipin 2009-03-21 11:39:53 UTC
From Issue 158674 (by ejvyas):

Every time there is a new version of Netbeans released, a new software needs to be installed on the system. This is
ridiculous. If you check other Java based IDEs like Eclipse, MyEclipse, IntelliJ all IDEs use the push technology to
upgrade the IDE and not install a new version. New version of netbeans needs to be downloaded separately by the use (who
has to be aware that such a version is released), installed and settings have to be imported over. There is still a lot
of confusion over such method and it is subject to a lot of discussion on the forums eg:
http://forums.netbeans.org/ptopic4949.html

I believe the use needs to have a feature where he can directly upgrade and not install in a clean directory. It leads
to multiple stale versions of Netbeans being installed on the poor developers PC
Comment 13 ejvyas 2009-03-21 12:32:29 UTC
Every time there is a new version of Netbeans released, a new software needs to be installed on the system. This is
ridiculous. If you check other Java based IDEs like Eclipse, MyEclipse, IntelliJ all IDEs use the push technology to
upgrade the IDE and not install a new version. New version of netbeans needs to be downloaded separately by the use (who
has to be aware that such a version is released), installed and settings have to be imported over. There is still a lot
of confusion over such method and it is subject to a lot of discussion on the forums eg:
http://forums.netbeans.org/ptopic4949.html

I believe the use needs to have a feature where he can directly upgrade and not install in a clean directory. It leads
to multiple stale versions of Netbeans being installed on the poor developers PC
Comment 14 caesar2k 2009-05-09 07:08:21 UTC
Auto Updating is common sense. Everything that is worth keeping auto-updates itself. For me, starts with windows. Then
Ubuntu, CentOS, with Aptitude, RPM, YUM etc. I agree, it's ridiculous to have 6 different versions of Netbeans
installed. I have at the moment, 6.0, 6.1, 6.5 M1, 6.5.1 (currently using), 6.7M3, 7.1, it's nonsense. 
Since Netbeans is Java, it should be easily upgradeable (scatered files all over many folders). Like people here pointed
out, Eclipse does it (Aptana does as well, since it's based on eclipse). 
I'm so used to an auto updating program, that I find my self, while idleing, clicking "Help" > "Check for Updates", but
it's usually the same stuff (CVS, Subversion, Task List).
Comment 15 ejvyas 2009-05-09 13:55:26 UTC
With so many people concerned about this and voting for this I believe the priority should be raised to P2 or P1. This
needs to be addressed soon. Its ridiculous to have multiple versions of the same IDE - more confusion, more space, more
configuration, waste of time!
Comment 16 caesar2k 2009-05-10 00:56:27 UTC
There another similar request at issue 135279 -> http://www.netbeans.org/issues/show_bug.cgi?id=135279
And a duplicate at http://www.netbeans.org/issues/show_bug.cgi?id=139016
And a consideration on the wiki http://wiki.netbeans.org/NetBeansMajorVersionUpgrade
Comment 17 dlipin 2009-12-21 04:23:37 UTC
*** Bug 178871 has been marked as a duplicate of this bug. ***
Comment 18 aliosman 2010-01-21 15:31:52 UTC
we should be able to upgrade our previous version of netbeans without having to create another list of installation directories of new version. i mean new version installation should be installed upon the previous directories. if i want to use only the new version i will no need to keep the previous one as a whole(just upgraded parts will change)  and there should be such an installation option.
Comment 19 caesar2k 2010-08-24 01:05:12 UTC
Created attachment 101618 [details]
Not funny anymore (if ever was)
Comment 20 caesar2k 2010-08-24 01:08:29 UTC
This issue is 3 years old, and still the same problem. I'm not a Java programmer, I'm mainly a Web and Win32 programmer, but how difficult would it be for one folder called Netbeans be upgraded/overwritten with new versions?? The "Help" > "Check for Updates" menu didn't upgrade from 6.9 to 6.9.1, had to install yet another folder with another scattered version of Netbeans... downloading 190MB every new release isn't funny you know
Comment 21 nesQuick 2011-04-01 17:36:10 UTC
As caesar2k already mentioned, I think this is an very important issue. So I voted too.
Comment 22 snd 2011-04-04 08:53:01 UTC
I'm also a bit dissapointed in the Netbeans update mechanism. The installer creates a new netbeans folder on every update.

It's also not possible to select the correct netbeans installation for update. It asks me if it should import the settings of my oldest(!) netbeans installation.
Comment 23 schtefan 2012-04-04 12:42:02 UTC
NetBeans 7.1.1 is now released, there still is not progress at all on this feature...
Comment 24 meanyack 2012-04-18 15:01:41 UTC
I just registered to say we need this. Now 7.1.1 is released which means I will have one more netbeans on my computer even if I already have 6.7, 6.8, 7.0.1
Comment 25 bradjo 2012-05-15 17:47:23 UTC
PLEASE add this functionality to detect and upgrade the existing IDE in place OR to add a new install at a path to be determined by the end user. But at the very least during component upgrade checks the main IDE base should notify when an update is available even if it has to be done entirely manually.

This is the default behavior of most software today.
Comment 26 gregorytechsoft 2012-06-13 13:41:49 UTC
ditto, everything said above. I honestly _love_ NetBeans; I've been using it since version 3.4 or so. Currently, preparing to upgrade to 7.2 but hoping some kind of "intelligent upgrade" can smooth the transition...
Comment 27 alexgieg 2012-10-26 12:46:38 UTC
I should confess this issue took me by surprise. I started using NetBeans very recently for PHP development with version 7.2, after reading many reviews of PHP IDEs. Today, I read somewhere 7.2.1 was available, so I went to the search for updates option. I was confused when it wasn't found, so I went to download the installed manually, and tried to install it by hand. At that point it became somewhat more confusing that it wanted to install to its own "c:\Program Files\Netbeans 7.2.1" folder rather than the original "c:\Program Files\Netbeans 7.2", but I thought: "Eh, I'll just change it." But things turned for the weird once the installer complained the older folder wasn't empty. How come?

Then I googled around and found this bug track, at which point I've switched from surprise and confusion to full blown bafflement. Full reinstallation? Seriously? For a minor x.x.1 update? Actually, seriously *seriously*? And the report is 5 years old? And it hasn't been fixed in over 5 years?

Wow. Just... wow.
Comment 28 Petr Jiricka 2012-10-26 15:50:46 UTC
That's weird, because micro updates like 7.2.1 *can* be done using the update center. Didn't you get a notification about the update in your 7.2?
Comment 29 alexgieg 2012-10-26 16:26:02 UTC
(In reply to comment #28)
> That's weird, because micro updates like 7.2.1 *can* be done using the update
> center. Didn't you get a notification about the update in your 7.2?

I've received some updates to plugins in the last few days, but the IDE itself is at 7.2 (Build 201207171143), and searching for updates informs it's up to date, so no hint even that 7.2.1 is available. Also, http://netbeans.org/community/releases/72/install.html#upgrading informs that:

"If you have an existing installation of NetBeans IDE you can choose whether or not to import the user settings from the existing user directory when you run NetBeans IDE 7.2.1 for the first time.

"Note: Incremental version upgrades of the IDE cannot be performed at this time. To upgrade to the most recent version you must download the latest installer."

So, at best full install followed by importing of settings, but not of anything else (such as 3rd party plugins?), and no in place update of the whole package.
Comment 30 alexgieg 2012-10-26 16:38:32 UTC
(In reply to comment #29)
> (In reply to comment #28)
> So, at best full install followed by importing of settings, but not of anything
> else (such as 3rd party plugins?), and no in place update of the whole package.

Correcting myself: the plugins did indeed came over. I should have tested before asking. My bad. :(
Comment 31 Coen 2012-11-26 14:44:27 UTC
I am big fan of Netbeans and I am using it since version 5.5 or so. But this issue is annoying me since then. I really **REALLY** would appreciate it if this feature could be build into the installer!!

Please..
Comment 32 Libor Fischmeistr 2013-01-15 09:43:39 UTC
*** Bug 182444 has been marked as a duplicate of this bug. ***
Comment 33 meanyack 2013-02-28 09:23:14 UTC
I'm (again, as always) downloading new version now. I fed up with downloading, installing, moving all projects to new one, exporting/importing my previous options, and removing old version... 

Maybe we can create something like Netbeans updater installed independent of Netbeans (like Apple does in many products) which checks for a new version and asks download and overwrite the old ones.
Comment 34 gregorytechsoft 2013-03-05 20:12:07 UTC
(In reply to comment #33)
Actually, a separate updater might not be optimal; it would (I assume you to mean) require one more applet or dll to start up at boot time. While I would seriously *seriously* !seriously! like to be offered the full upgrade via an in-IDE notification, I do not think a separate installer would necessarily be helpful.

Also, looking "upstream", I would wish Java itself was just as considerate for upgrades; as goes for many of us here, I tend to be the "family pc support technician", and I also tend to notice multiple parallel copies of Java, even singular old versions because the family member says Java is "messy".

But I also have the unique tendency to also see the other side of an issue; a developer in an institutional or organizational setting may be required to work with a particular version; whereas I believe the independent or solo developer just wants things to be upgraded to current standards. Both are valid viewpoints that have differing perspectives but I am afraid the people in the boardrooms who would argue for keeping things the way they are may out-shout the voice of the solo developer. So, which is more important to Sun ... er, Oracle ... er, whatever comes next?

This is the heart of the matter. Solo developer, versus corporate developer. I'm not really trying to start a "us versus them" mentality; but it truly feels like this is the issue.
Comment 35 uuf6429 2014-01-20 09:59:21 UTC
6 years down the line and we're still missing this feature - which according to some, (from above), is relatively easy to achieve.

I don't want to sound condescending or anything, but we really need this. Loyal Netbeans users end up having to uninstall/install each time, not considering that old plugins and settings are not always picked up correctly.

Chris.
Comment 36 mikato 2014-02-11 16:43:55 UTC
This is why I don't upgrade my NetBeans unless I have to. Do the NetBeans developers really want that? I figured it would be best if they had people updating their NetBeans installations quite frequently. That way any bugs aren't exposed for very long. I was on 6.9.1 for quite a long time, and I finally loaded 7.0.1 because I couldn't take the problems I had with NetBeans. It had all kinds of problems bogging down, checking for external changes, failing at compiling, blah blah to the point where it became unusably slow most of the time so finally I updated hoping that cleared the issues because I had seen some related bug reports and even contributed it to some (other people reproducing was always a problem in the bug reports). Now I am on 7.0.1 and NetBeans has started bogging down frequently again. 

I contemplate updating, but I am loathe to do that. There is no friendly way to update. There is no message or reassurance that my projects will be safe, and that I can load them up as before. I need to see this in the program, not some help doc somewhere on the web.

"Note: Incremental version upgrades of the IDE cannot be performed at this time. To upgrade to the most recent version you must download the latest installer."
https://netbeans.org/community/releases/73/install.html#upgrading

Is that how you upgrade your NetBeans installation? It seems like that would just leave the old version somewhere like everyone is complaining about. And your projects? How about at least a nice little description of a few steps on how to upgrade??? When I google for "how to update netbeans", I don't see much helpful! Most of the top search results are Stack Overflow questions. I'd count those as votes here.
Comment 37 Fallout84 2014-04-13 13:23:10 UTC
"This bug was already fixed.
Please update your build of NetBeans to the latest build of Dev where bug #243494 is fixed"

Really i need to download last nightly and install it as new app to get working jslibs? Ridiculous.
Comment 38 patrikho 2015-04-30 09:12:39 UTC
This should really be a non-issue and an obvious part of a mature developer tool since it would save time and effort for the netbeans user community. It would also result in happy developers/users of netbeans, I am seriously considering leaving netbeans in favor of a more mature development tool like Eclipse. I'm sitting on 7 different versions of netbeans and am about to install number 8 that is a nightly build that I need due to the troubles with web service client code generation. I'm fed up with this. It means that all configuration files and everything has to be moved/copied again, for me a painstaking process that I can live without.
Comment 39 totumfacky 2016-02-05 23:01:52 UTC
I changed version to 8.1 because this issue concerns most recent edition of Netbeans.
Why I can't just update my Netbeans 8.0.2 to 8.1? Installer pointed to 8.0.2 version's directory says its not empty!
Comment 40 gochev 2016-09-14 15:51:28 UTC
+1 

Indeed at least make the installer like in IntelliJ IDEA one e.g. not to have automated check for updates you are done (aka linux way), but at least to make it more like windows way :  where you point to your old installation all settings are taken and netbeans is replaced and all plugins are reinstalled/redownloaded etc. (maybe if plugin is not available this to be shown prior to upgrade) or something similar.
Comment 41 davidstein 2017-05-10 06:01:09 UTC
I've been using netbeans for years now and voting on this issue is literally what finally made me register an account here. 

Upgrading to a new major release is a pain in the neck, particularly if you have grown accustomed to a certain setup after long-time use of the IDE. I really like NetBeans, but its lack of a solid upgrade mechanism has made me seriously consider migrating several times now. It's not just that you need to fetch, install and migrate new major releases manually, netbeans won't even tell you if your version is outdated. Right now, my "notification mechanism" is when one of the plugins finally refuses to update.

I can live without an installer that does a full auto-upgrade, but even just having an option to at least auto-adopt my old settings would be a boon.
Comment 42 ChrisLE 2017-05-11 09:38:57 UTC
In my opinion and the knowledge with IDEs and editors all big IDEs like the JetBrain collection or Visual Studio or maybe Eclipse too, will not update the major releases like VS 2015, 2017 WebStorm, PHPStorm, IntelliJ 13, 14, 15, 2016, 2017 so exact the same behaviour as NetBeans.


All those IDEs will update minor releases, bug fixes, patches and minor releases like 12.1, 12.2 2017.1 and VS too I think. The same behaviour has VS Code. Each month they release a new version and you can update it via the editor itselfs. from 1.1 to 1.12 there is no problem.

NetBeans can't handle this too. It is not possible to update inside the IDE from 8.0 to 8.1 or 8.2. It is only possible to update plugins and other stuff inside the IDE, add patches and bug fixes I think like 8.1.1 (only e.g.) But I don't know atm.

For me Major releases are ok to update it separately but minor, bug fixes and patches should be possible inside the IDE.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo